/*===============================================================
  Ethernet driver for Lucent WaveLAN based PC cards

  file: LucentWave.cp
  protocol class implementation

  Author: Hiroshi Noguchi

  03/04/2000	1st.
===============================================================*/




#if 1	/* 05/15/2002 add */
#include "frames/objects.h"
#endif


#ifndef	__TDKETHERNET_IMPL_H
#include "LucentWave.impl.h"
#endif

#ifndef	__LANTERNEVENTS_H
#include "LanternEvents.h"
#endif

#ifndef	__DELAYTIMER_H
#include "DelayTimer.h"
#endif

#ifndef	__REGISTERRDWR_H
#include "RegisterRdWr.h"
#endif

#ifndef __BUFFERLIST_H
#include "BufferList.h"
#endif

#ifndef __LISTITERATOR_H
#include "ListIterator.h"
#endif

#ifndef __LIST_H
#include "List.h"
#endif

#ifndef	__COMMERRORS_H
#include "CommErrors.h"
#endif

#ifndef __NEW_H
#include <New.h>
#endif




/*===========================
  RpCtO
===========================*/
#define	FIX_HERMES_BUG
#define	FIX_HERMES_STATS_BUG




/*
 * Cxgg[Xp
 */
#define	TestEventTracing	(0 && defined(forDebug)) /* Turn on event tracing */

#if TestEventTracing
#define	kDB__pHISTORYCOLLECT	1
#include "historyCollectorMACRO.h"
#endif



#define	CSW_DEB_PRINT	(1)

#if CSW_DEB_PRINT
#define	DEB_PRINT(a)		printf a
#define	DEB_ASSERT(lvl,a)	{ if(fDebugLevel >= (lvl)){ printf a; }}
#else
#define	DEB_PRINT(a)
#define	DEB_ASSERT(lvl,a)
#endif




/*================================
  萔`
================================*/
/*---------------------------
  hCoŗLCxg`
---------------------------*/
#define	DRV_NAME			'wi11'

/*
 * ^C}[Cxg
*/
#define kWaveLANEventTimer		DRV_NAME,'timr',0

/*
 * r[RM(?)p^C}[Cxg
 */
#define	kWaveLANEventBeatTimer	DRV_NAME,'beat',0


/*-----------------------------
  XNvgԌ̊OCxg
-----------------------------*/
/*
 * ݒp[^ Cxg
 * (driver client --> driver)
 */
#define	kWaveLANEventSetConfig		DRV_NAME,'scfg',3

/*
 * ݒp[^o Cxg
 * (driver client <-- driver)
 */
#define	kWaveLANEventGetConfig		DRV_NAME,'gcfg',1

/*
 * o^R[h`FbN Cxg
 * (driver client <--> driver)
 */
#define	kWaveLANEventRegCodeCheck	DRV_NAME,'rgck',2


/*
 * ݒp[^ ڔԍ
 *
 * ###  ###
 * Newton ScriptŋLqGUIƒ`vĂ
 */
enum {
	CONF_ID_VAL_CHANNEL	= 1,	/* l:   g`l (1 - 14) */
	CONF_ID_STR_SSID,			/* : SSID = lbg[N */
	CONF_ID_VAL_MODE,			/* l:   ʐM[h (infrastructure/ad-hoc) */
	CONF_ID_VAL_WEP_ENA,		/* l:   WEP ON/OFF */
	CONF_ID_STR_WEP_KEY,		/* : WEPL[ "0x"Ŏn܂Ƃ16iƂ */
	CONF_ID_VAL_ROAMING,		/* l:   [~O ON/OFF */
	CONF_ID_VAL_POWER,			/* l:   ȓd̓[h ON/OFF */
	CONF_ID_VAL_REGIST_OK,		/* l:   o^ς݂ł邩ǂ? */
};

/*
 * ʐM[h
 *
 * ###  ###
 * Newton ScriptŋLqGUIƒ`vĂ
 */
enum {
	WVLAN_MODE_NONE	= 0,
	WVLAN_MODE_INFRA,			/* infrastructure[h */
	WVLAN_MODE_ADHOC,			/* 802.11 ad-hoc[h (IBSS?) */
	WVLAN_MODE_ADHOC_DEMO,		/* ad-hoc[h(IBSS?) */

	WVLAN_DEFAULT_MODE	= WVLAN_MODE_INFRA
};


/*
 * t@[EFA
 */
enum {
	FIRMWARE_TYPE_NONE		= 0,
	FIRMWARE_TYPE_LUCENT,
	FIRMWARE_TYPE_INTERSIL,
	FIRMWARE_TYPE_SYMBOL
};


/*
 * Nԃ`FbN 
 */
#define	TC_LINK_CHECK	(500)			/* 500[msec] */

#define	TC_INQUIRE		(60 * 1000)		/* 60[sec] */


/*
 * Cxgg[XɊւ`
 *
 * NOTE: Event trace records real time events for the debugger.
 *		 This feature depends on which debugger is used and
 *		 may not be available to developers
 */
enum {
	kLucentEventCommandReg			=	1,
	kLucentEventIntRxTxStatusReg,
	kLucentEventRxNxtCur,
	kLucentEventRxPagesPktNextBnry,

	kLucentEventInit,
	kLucentEventEnable,
	kLucentEventDisable,
	kLucentEventTimerExpired,
	kLucentEventInterruptHandler,
	kLucentEventSendBuffer,
	kLucentEventSendCBufferList,
	kLucentEventGetDeviceAddress,
	kLucentEventAddMulticastAddress,
	kLucentEventDelMulticastAddress,
	kLucentEventGetLinkIntegrity,
	kLucentEventSetPromiscuous,
	kLucentEventGetThroughput,

	kLucentEventNICInit,
	kLucentEventBufferSize,
	kLucentEventBufferPages,
	kLucentEventStartRx,
	kLucentEventStartTx,
	kLucentEventStopRxTx,
	kLucentEventRxOk,
	kLucentEventRxError,
	kLucentEventRxBufferOverflow,
	kLucentEventRxBadPageOrSize,
	kLucentEventRxNoBufferAvail,
	kLucentEventTxOk,
	kLucentEventTxError,
	kLucentEventRxPacketXfer,
	kLucentEventTxDone,
	kLucentEventRemoteDMAXferRead,
	kLucentEventRemoteDMAXferWrite,
	kLucentEventRemoteDMAXferData,
	kLucentEventWaitForStatus,
	kLucentEventWaitForIdle,

	kLucentEventTxQueueInit,
	kLucentEventTxQueueAddPacket,
	kLucentEventTxQueueRemovePacket,
	kLucentEventTxQueueGetPacket,
	kLucentEventTxQueueOverflow,
	kLucentEventTxQueueFirstPacket,
	kLucentEventTxQueueLastPacket,

	kLucentEventDriverAPIEnter,
	kLucentEventDriverAPIExit,

	kLucentEventDescSize
};


/*
 * Cxgg[XR[h𐶐邽߂̃}N`
 */
#if TestEventTracing

#define ADD_TRACE_EVENT(id, byte, short)	\
			TRACE_MESSAGE(fEventTraceCollector, id, byte, short);
#define ADD_TRACE_ADDR()					\
			TRACE_FUNCTION(fEventTraceCollector);

#define ADD_TRACE_EVENT_TxQ(id, byte, short)	\
			TRACE_MESSAGE(fMB8696x->fEventTraceCollector, id, byte, short);
#define ADD_TRACE_ADDR_TxQ()				\
			TRACE_FUNCTION(fMB8696x->fEventTraceCollector);

#else

#define ADD_TRACE_EVENT( id, byte, short)
#define ADD_TRACE_ADDR()

#define ADD_TRACE_EVENT_TxQ( id, byte, short)
#define ADD_TRACE_ADDR_TxQ()

#endif





#if CSW_DEB_PRINT
/*--------------------------------
  dumpMem:
--------------------------------*/
void  dumpMem( UINT8*  bp, INT16  bytes )
{
	INT16	i;

	for( i = 0 ; i < bytes ; i++ ){
		DEB_PRINT(("%02X ",*bp++));
		if( (i % 0x10) == 0x0F ){
			DEB_PRINT(("\n"));
		}
	}
	DEB_PRINT(("\n"));
}
#else
#define	dumpMem(a1,a2)
#endif




/*=============================================================
  vgRNX ֐
=============================================================*/




/* Magic stuff, do not touch. (For protocol class) */
PROTOCOL_IMPL_SOURCE_MACRO(TLucentWaveLAN)




//
//	TLanternDriver* TLucentWaveLAN::New()
//
//	Protocol class constructor
//
//	Allocate and set up local varibles here.
//
//	This is called when the card is inserted.
//	The variables fCardSocket, fCardPCMCIA and 
//	fDriverAPI are NOT set up right now. They are only available later in Init().
//
//	If there is a embeded class in the protocol class, the constructor
//	of the class is not executed when the protocol class is initialized.
//	This is the limitation of the protocol class.
//	It need be initialized here in the NEW(). For example:
//
//	PROTOCOL TLucentWaveLAN : ...
//	{
//		...
//		TFoo	fFoo;			// A embeded class
//		...
//	}
//
//	TLucentWaveLAN::New()
//	{
//		...
//		new (&fFoo) TFoo;		// Execute the constructor
//		...
//	}
//
/*--------------------------------
  ::New:
--------------------------------*/
TLanternDriver* TLucentWaveLAN::New()
{
#ifdef forDebug
	/*
	 * For debugging only.
	 * The fDebugControls is used for selecting run time debugging action.
	 */
	fDebugSignature = 'dbug';		/* For locating fDebugControls in debugger */
	fDebugControls = 0;				/* Clear run time debug controls */
#endif

	fDebugLevel = 0;

	/*****************************/
	/*       ϐ          */
	/*****************************/
	NICInitVars();

	fStatus = DRV_STAT_NONE;

	fMulticastAddrDataBase	= nil;

	/* NX̃RXgN^s */
	new (&fTickTime) TTime;
	new (&fTimeBeat) TTime;

	/* MppPbgobt@ ǗpXg */
	fPtrListTxBufPool	= nil;
	fPtrListTxBufQueue	= nil;

#if TestEventTracing
	/*
	 * Cxgg[X` n
	 */
	BEGIN_TRACE_DECLARATIONS(ClassInfo()->ImplementationName(),
							 512, (kLucentEventDescSize - 1),
							 fEventTraceCollector, fEventTraceCauseDescs);

	/*
	 * Cxgg[XR[hƕ\̃}bsOݒ肷
	 */
	DEFINE_TRACE_ENTRY(kLucentEventCommandReg,			"CommandReg#        ");
	DEFINE_TRACE_ENTRY(kLucentEventIntRxTxStatusReg,	"IntRxTxStatusReg#  ");
	DEFINE_TRACE_ENTRY(kLucentEventRxNxtCur,			"RxNxtCur#          ");
	DEFINE_TRACE_ENTRY(kLucentEventRxPagesPktNextBnry,	"RxPagesPktNextBnry#");

	DEFINE_TRACE_ENTRY(kLucentEventInit,				"Init               ");
	DEFINE_TRACE_ENTRY(kLucentEventEnable,				"Enable             ");
	DEFINE_TRACE_ENTRY(kLucentEventDisable,				"Disable            ");
	DEFINE_TRACE_ENTRY(kLucentEventTimerExpired,		"TimerExpired       ");
	DEFINE_TRACE_ENTRY(kLucentEventInterruptHandler,	"InterruptHandler   ");
	DEFINE_TRACE_ENTRY(kLucentEventSendBuffer,			"SendBuffer         ");
	DEFINE_TRACE_ENTRY(kLucentEventSendCBufferList,		"SendCBufferList    ");
	DEFINE_TRACE_ENTRY(kLucentEventGetDeviceAddress,	"GetDeviceAddress   ");
	DEFINE_TRACE_ENTRY(kLucentEventAddMulticastAddress,	"AddMulticastAddress");
	DEFINE_TRACE_ENTRY(kLucentEventDelMulticastAddress,	"DelMulticastAddress");
	DEFINE_TRACE_ENTRY(kLucentEventGetLinkIntegrity,	"GetLinkIntegrity   ");
	DEFINE_TRACE_ENTRY(kLucentEventSetPromiscuous,		"SetPromiscuous     ");
	DEFINE_TRACE_ENTRY(kLucentEventGetThroughput,		"GetThroughput      ");

	DEFINE_TRACE_ENTRY(kLucentEventNICInit,				"NICInit            ");
	DEFINE_TRACE_ENTRY(kLucentEventBufferSize,			"BufferSize         ");
	DEFINE_TRACE_ENTRY(kLucentEventBufferPages,			"BufferPages        ");
	DEFINE_TRACE_ENTRY(kLucentEventStartRx,				"StartRx            ");
	DEFINE_TRACE_ENTRY(kLucentEventStartTx,				"StartTx            ");
	DEFINE_TRACE_ENTRY(kLucentEventStopRxTx,			"StopRxTx           ");
	DEFINE_TRACE_ENTRY(kLucentEventRxOk,				"RxOk              ");
	DEFINE_TRACE_ENTRY(kLucentEventRxError,				"RxError         ");
	DEFINE_TRACE_ENTRY(kLucentEventRxBufferOverflow,	"RxBufferOverflow");
	DEFINE_TRACE_ENTRY(kLucentEventRxBadPageOrSize,		"RxBadPageOrSize ");
	DEFINE_TRACE_ENTRY(kLucentEventRxNoBufferAvail,		"RxNoBufferAvail");
	DEFINE_TRACE_ENTRY(kLucentEventTxOk,				"TxOk              ");
	DEFINE_TRACE_ENTRY(kLucentEventTxError,				"TxError         ");
	DEFINE_TRACE_ENTRY(kLucentEventRxPacketXfer,		"RxPacketXfer       ");
	DEFINE_TRACE_ENTRY(kLucentEventTxDone,				"TxDone             ");
	DEFINE_TRACE_ENTRY(kLucentEventRemoteDMAXferRead,	"RemoteDMAXferRead  ");
	DEFINE_TRACE_ENTRY(kLucentEventRemoteDMAXferWrite,	"RemoteDMAXferWrite ");
	DEFINE_TRACE_ENTRY(kLucentEventRemoteDMAXferData,	"RemoteDMAXferData**");
	DEFINE_TRACE_ENTRY(kLucentEventWaitForStatus,		"WaitForStatus      ");
	DEFINE_TRACE_ENTRY(kLucentEventWaitForIdle,			"WaitForIdle        ");

	DEFINE_TRACE_ENTRY(kLucentEventTxQueueInit,			"TxQueueInit        ");
	DEFINE_TRACE_ENTRY(kLucentEventTxQueueAddPacket,	"TxQueueAddPacket   ");
	DEFINE_TRACE_ENTRY(kLucentEventTxQueueRemovePacket,	"TxQueueRemovePacket");
	DEFINE_TRACE_ENTRY(kLucentEventTxQueueGetPacket,	"TxQueueGetPacket   ");
	DEFINE_TRACE_ENTRY(kLucentEventTxQueueOverflow,		"TxQueueOverflow");
	DEFINE_TRACE_ENTRY(kLucentEventTxQueueFirstPacket,	"TxQueueFirstPacket");
	DEFINE_TRACE_ENTRY(kLucentEventTxQueueLastPacket,	"TxQueueLastPacket");

	DEFINE_TRACE_ENTRY(kLucentEventDriverAPIEnter,		"DriverAPIEnter     ");
	DEFINE_TRACE_ENTRY(kLucentEventDriverAPIExit,		"DriverAPIExit      ");

	END_TRACE_DECLARATIONS(0);
	/*
	 * Cxgg[X` ܂
	 */
#endif

	return( this );		/* Always return this */
}


/*
 * Clean up and free all momory allocations
 * This is called when the card is removed.
 */
/*--------------------------------
  ::Delete:
--------------------------------*/
void TLucentWaveLAN::Delete()
{
	/*
	 * NOTE: PowerOn() and PowerOff() have to be balanced.
	 *       So turn power off if we turn it on.
	 */
	/* J[hʓdĂꍇ́CJ[hւ̓df */
	if( fStatus & DRV_STAT_CARD_POWER_ON ){
		fDriverAPI->PowerOff();
	}

	/* ŐNX̌n */
	delete fMulticastAddrDataBase;

#if 0
	/* TTime has no destructor  */
	/* (if it did we would need to run it explicitly here) */
	fTickTime.~TTime();
	fTimeBeat.~TTime();
#endif

#if TestEventTracing
	/* Remove event trace stuff */
	TRACE_RELEASE(fEventTraceCollector, fEventTraceCauseDescs);
#endif
}




/*=============================================================
  Lantern^XNT[rX֐
=============================================================*/


/*
 * J[h}ꂽƂɌĂяoD
 * ŁChCoCJ[hZbgAbv邱ƁD
 */
/*--------------------------------
  ::Init:
--------------------------------*/
NewtonErr TLucentWaveLAN::Init()
{
	NewtonErr	err = noErr;
	ULong		i;

	ADD_TRACE_EVENT(kLucentEventInit, 0, 0);

	/*********************************************/
	/*   PCJ[hC^[tF[XƂĂ̏  */
	/*********************************************/
	/*
	 * TCardPCMCIACIS̏̑唼܂ށD
	 * n[hEFAAhẌꕔĺCTCardPCMCIA瓾D
	 * 邢͂̐l̓n[hR[fBOĂD
	 *
	 * configurationWX^̃x[XAhX,
	 * TCardPCMCIAfRegisterBaseAddressɕێĂD
	 *
	 * ܂CTCardPCMCIÁCRtBM[VGg̃Xg
	 * TCardConfigurationɕێD
	 * ɁCRtBM[VGg̔ԍ(TCardConfiguration
	 * fConfigurationNumberɓĂ)ێD
	 * RtBM[VGgłI/OAhX́C
	 * TCardConfigurationfIoAddressesɂD
	 *
	 * TCardSocket́CPCMCIARg[ASIC̏̃n[hEFAC[
	 * 񋟂D
	 * ̓Iɂ́CAgr[gCRCI/Ox[XAhX
	 * Ƃ́D
	 * ܂C\Pbg̃oX@\񋟂D
	 */
	Boolean		flagCard3VAvail;
	Boolean		flagCard5VAvail;

	flagCard3VAvail = (fCardSocket->VccVoltageSpec() & kPCMCIA3p3VAvailable) ? true : false;
	flagCard5VAvail = (fCardSocket->VccVoltageSpec() & kPCMCIA5VAvailable) ? true : false;
#if 1	/* for debug */
	printf("3.3V: %d,  5.0: %d\n",flagCard3VAvail,flagCard5VAvail);
#endif

	/* CIS擾 */
	TCardConfiguration*		cardConfig			= nil;
	ULong					numOfConfigEntry	= fCardPCMCIA->fNumOfConfigEntry;
	ULong					ioAddresses			= 0;
	Long					tmp_idx;

	/* J[hI3.3VL̂Ƃ́C3.3V̐ݒT */
	if( flagCard3VAvail == true ){
		tmp_idx = -1;

		for( i = 0 ; i < numOfConfigEntry ; i++ ){
			if( (cardConfig = fCardPCMCIA->GetCardConfiguration( i )) ){
				if( cardConfig->fVcc[kVNominal] == k3p3Volts ){
					tmp_idx = i;

					ioAddresses = cardConfig->fIoAddresses[0];
					if( (0x100 <= ioAddresses) && (ioAddresses <= 0x3E0) ){
						/* ̂܂ */
						flagCard5VAvail = false;
						break;
					}
				}
			}
		}

		/* I/OAhX̎w肪Ȃꍇւ̑Ώ */
		if( (i >= numOfConfigEntry) && (tmp_idx >= 0) ){
			ioAddresses = 0x200;
			cardConfig = fCardPCMCIA->GetCardConfiguration( tmp_idx );
			flagCard5VAvail = false;
		} else{
			flagCard3VAvail = false;
		}
	}

	/* 5VL̂Ƃ́CݒT */
	if( flagCard5VAvail == true ){
		tmp_idx = -1;

		for( i = 0 ; i < numOfConfigEntry ; i++ ){
			if( (cardConfig = fCardPCMCIA->GetCardConfiguration( i )) ){
				if( cardConfig->fVcc[kVNominal] == k5p0Volts ){
					tmp_idx = i;

					ioAddresses = cardConfig->fIoAddresses[0];
					if( (0x100 <= ioAddresses) && (ioAddresses <= 0x3E0) ){
						/* ̂܂ */
						break;
					}
				}
			}
		}

		/* I/OAhX̎w肪Ȃꍇւ̑Ώ */
		if( (i >= numOfConfigEntry) && (tmp_idx >= 0) ){
			ioAddresses = 0x200;
			cardConfig = fCardPCMCIA->GetCardConfiguration( tmp_idx );
		} else{
			flagCard5VAvail = false;
		}
	}

	XREQUIRE_ACTION(cardConfig, exit, err = kError_No_Usable_Configurations;);

	/* x[XAhXݒ肷 */
	fCardConfigBaseAddr	= fCardSocket->AttributeMemBaseAddr() +
									fCardPCMCIA->fRegisterBaseAddress;

	/* RtBM[VԍoĂ */
	fCardConfigNumber	= cardConfig->fConfigurationNumber;

	fFlagCard3VAvail	= flagCard3VAvail;
#if 1	/* for debug */
	printf("fFlagCard3VAvail = %d\n",fFlagCard3VAvail);
#endif

	/* I/OAhXoĂ */
	fNICBaseAddr		= fCardSocket->IOBaseAddr() + ioAddresses;

	/**************************************/
	/*           ϐ               */
	/**************************************/
	fLinkIntegrity		= false;
	memset( fEthernetAddr, 0, sizeof(fEthernetAddr) );
	fFlagBeatTimer		= false;
	fTimerPosted 		= false;

	/* }`LXgAhXf[^x[X NX */
	fMulticastAddrDataBase = new TMulticastAddrDataBase;
	XREQUIRE_ACTION(fMulticastAddrDataBase, exit, err = kError_No_Memory;);

	/**************************************/
	/*        n[hEFA          */
	/**************************************/
	/* "Init()"̎_ŁCJ[h͊ɒʓdĂ */
	if( (err = InitCard()) ){
		goto exit;
	}

	/* Lanternv֐ǉ */
	fDriverAPI->AddEventHandler(kLanternSendBuffer,
								(DriverProcPtr) &TLucentWaveLAN::SendBuffer);
	fDriverAPI->AddEventHandler(kLanternSendCBufferList,
								(DriverProcPtr) &TLucentWaveLAN::SendCBufferList);
	fDriverAPI->AddEventHandler(kLanternGetDeviceAddress,
								(DriverProcPtr) &TLucentWaveLAN::GetDeviceAddress);
	fDriverAPI->AddEventHandler(kLanternAddMulticastAddress,
								(DriverProcPtr) &TLucentWaveLAN::AddMulticastAddress);
	fDriverAPI->AddEventHandler(kLanternDelMulticastAddress,
								(DriverProcPtr) &TLucentWaveLAN::DelMulticastAddress);
	fDriverAPI->AddEventHandler(kLanternGetLinkIntegrity,
								(DriverProcPtr) &TLucentWaveLAN::GetLinkIntegrity);
	fDriverAPI->AddEventHandler(kLanternSetPromiscuous,
								(DriverProcPtr) &TLucentWaveLAN::SetPromiscuous);
	fDriverAPI->AddEventHandler(kLanternGetThroughput,
								(DriverProcPtr) &TLucentWaveLAN::GetThroughput);

	/*
	 * Iȃ^C}[T[rXnh ZbgAbv
	 */
	fDriverAPI->AddEventHandler(kWaveLANEventTimer,
								(DriverProcPtr) &TLucentWaveLAN::TimerExpired);

	fDriverAPI->AddEventHandler( kWaveLANEventBeatTimer,
								 (DriverProcPtr)&TLucentWaveLAN::TimerProcBeat );

	/*
	 * OCxgnho^
	 */
	fDriverAPI->AddEventHandler( kWaveLANEventSetConfig,
								 (DriverProcPtr)&TLucentWaveLAN::SetConfig );
	fDriverAPI->AddEventHandler( kWaveLANEventGetConfig,
								 (DriverProcPtr)&TLucentWaveLAN::GetConfig );
#if 0
	fDriverAPI->AddEventHandler( kWaveLANEventRegCodeCheck,
								 (DriverProcPtr)&TLucentWaveLAN::CheckRegCode );
#endif

  exit:;
	ADD_TRACE_EVENT(kLucentEventInit, 9, err);

	return( err );
}


/*
 * NewtonErr TLucentWaveLAN::Enable()
 *
 * Enable: set up card and start Rx
 *
 * This method is called whenever the services of the card are required by clients.
 * It is called once when the first client requires services. Subsequent clients
 * do not cause this call to be repeated. Clients of an Ethernet card can be AppleTalk,
 * TCP/IP or a protoLanternClient from NewtonScript.
 */
/*--------------------------------
  ::Enable:
  M
--------------------------------*/
NewtonErr TLucentWaveLAN::Enable()
{
	NewtonErr	err = noErr;
	Boolean		powerOn;
	INT16		ii;

	ADD_TRACE_EVENT(kLucentEventEnable, 0, 0);

//	DEB_ASSERT( 60, ("Enable()\n") );

	/* J[hɓd */
	fDriverAPI->PowerOn( &powerOn );

	/* dĂ邱ƂoĂ */
	fStatus |= DRV_STAT_CARD_POWER_ON;

	/*
	 * dOFF --> ON ɂȂƂɁC"powerOn"ϐ == TRUEɂȂD
	 * ̂Ƃɂ́Cn[hEFAKvD
	 *
	 * C_ł́C̃WbN܂삵ȂƂ悤Ȃ̂ŁC
	 * ɖCn[hEFAĂD
	 */
#if 0
	/* Check power was just just turned on in PowerOn() */
	if( powerOn )
#endif
	{
		if( (err = InitCard()) ){
			goto exit;
		}
	}

	/*
	 * - Mobt@ǗpXg𐶐
	 * - MpPbgobt@v[Ƀobt@Ȃ
	 */
#if (TX_PKT_NUM > 1)
	fPtrListTxBufPool	= new CList;
	fPtrListTxBufQueue	= new CList;
	for( ii = 0 ; ii < TX_PKT_NUM ; ii++ ){
		fPtrListTxBufPool->InsertLast( &(fTxPktBufArray[ii]) );
	}
#endif

	/* dɃ^C}NȂ悤ɂĂ */
	if( fTimerPosted == false ){
		/* ̃^XNgCxg󂯎悤Ƀ|Xg */
		fTimerPosted	= true;
		fTickTime		= GetGlobalTime() + TTime(TC_LINK_CHECK, kMilliseconds);
		fDriverAPI->PostLocalEvent(&fTickTime, kWaveLANEventTimer);
	}

	/* n[hEFA𑗎M\ɂ */
	if( (err = NICEnable()) ){
		goto exit;
	}

	/*
	 * M/M
	 */
	/* enableԂł邱Ƃo */
	fStatus |= DRV_STAT_ENABLED;

  exit:;
	ADD_TRACE_EVENT(kLucentEventEnable, 9, err);

	return( err );
}


/*
 * NewtonErr TLucentWaveLAN::Disable()
 *
 * Disable: stop Rx and Tx operations
 *
 * This method is called when there no more clients that require the services of the card,
 * or it has been determined that the card is no longer available in the system.
 */
/*--------------------------------
  ::Disable:
  M֎~
--------------------------------*/
NewtonErr TLucentWaveLAN::Disable()
{
	NewtonErr	err = noErr;

	ADD_TRACE_EVENT(kLucentEventDisable, 0, 0);

//	DEB_ASSERT( 60, ("Disable()\n") );

	/* Xe[^XdisableԂɂ */
	fStatus &= ~DRV_STAT_ENABLED;

	/*
	 * MEM~
	 */
	/* n[hEFA𑗎M֎~ɂ */
	err = NICDisable();

	/* J[h̓df */
	fDriverAPI->PowerOff();
	fStatus &= ~DRV_STAT_CARD_POWER_ON;

	/* Mobt@ǗpXgNXj */
#if (TX_PKT_NUM > 1)
	delete fPtrListTxBufPool;
	delete fPtrListTxBufQueue;
#endif

	ADD_TRACE_EVENT(kLucentEventDisable, 9, err);

	return( err );
}


/*
 * NewtonErr TLucentWaveLAN::InterruptHandler()
 *
 * Interrupt handler (called from task level, not in interrupt level)
 *
 * This method is called after an interrupt line on the card is asserted.
 * This method is dispatched as a priority event from the system interrupt handler
 * and as such is not 'true' interrupt code, consequently it does not have to execute as 
 * time critical or out-of-state code. However, as a priority event, it is dispatched
 * before any other pending RPCs waiting on the driver. The current minimum time between
 * a card interrupt and this method executing is approximately 50 mSecs but could be longer
 * depending on OS loading.
 *
 * There is a fundamental assumption that a Lantern device is capable of buffering inbound 
 * data for at least as long as required for the interrupt event to be dispatched. For high 
 * bit rate cards (wired Ethernet) on a busy network (e.g. large AppleTalk nets) this may
 * cause loss of packets. As a data link layer, lost packets are allowable, however some
 * protocols, especially AppleTalk on the Newton, may be fragile to loosing certain packets.
 */
/*--------------------------------
  ::InterruptHandler:
  J[h荞݃nh
--------------------------------*/
void TLucentWaveLAN::InterruptHandler()
{
	NewtonErr	err = noErr;

	ADD_TRACE_EVENT(kLucentEventInterruptHandler, 0, 0);

	/* n[hEFÅ荞ݏ[` */
	NICInterrupt();

	/* 荞ݏIʒm */
	/* This call is optional (here it's not really needed) */
	fDriverAPI->InterruptDone();
	
	ADD_TRACE_EVENT(kLucentEventInterruptHandler, 9, err);
}


/*
 * ULong TLucentWaveLAN::TimerExpired()
 *
 * This is a general purpose timer routine.  You may implement as many different timers
 * as needed for your particular implementation by adding different events and eventhandlers
 * for each timer.
 *
 * The three parts to defining this as a timer is to
 *
 * 1. Add an eventhandler to handle your specifically defined event
 * 2. Call PostLocalEvent with a delay for the time to send the event
 * 3. Implement the timer event handler method.
 *
 * This timer periodically checks the link integrity (although for this chipset it cannot
 * be detected so it just returns true).
 *
 * You can send this event out to clients that the link status has changed. 
 * This is not a necessary event but should be implemented if the link integrity 
 * can be detected by interrupt (or by timed event polling). If you detect 
 * the link is bad (packet errors say) you may send this event but should keep 
 * accepting further requests.
 */
/*--------------------------------
  ::TimerExpired:
--------------------------------*/
void TLucentWaveLAN::TimerExpired(void)
{
	if( fStatus & DRV_STAT_CARD_POWER_ON ){
		/*--- ʓdĂƂ ---*/
		Boolean	linkIntegrity;

		/* n[hEFAŃNԂo */
		linkIntegrity = NICGetLinkIntegrity();

		/* NԂωĂ΁CCxgƂă|Xg */
		if( linkIntegrity != fLinkIntegrity ){
			fDriverAPI->PostEvent( kLanternLinkIntegrity,
								  (ULong)(fLinkIntegrity = linkIntegrity));
		}

		/* ̃^XNgɃ^C}[Cxg|Xg */
		fTimerPosted	= true;
		fTickTime		= fTickTime + TTime(TC_LINK_CHECK, kMilliseconds);
		fDriverAPI->PostLocalEvent(&fTickTime, kWaveLANEventTimer);
	} else{
		/*--- ʓdĂȂƂ ---*/

		/* ȏC^C}[T[rXpȂ */
		fTimerPosted = false;
	}
}



/*=============================================================
  LanternNCAgT[rX֐
=============================================================*/


/*
 * void	  TLucentWaveLAN::SendBuffer(Ptr thePacket, Size packetSize)
 * void	  TLucentWaveLAN::SendCBufferList(CBufferList* thePacket)
 * NewtonErr TLucentWaveLAN::SendPacket(UChar* buffer, CBufferList* cBufferList, ULong packetSize)
 *
 * Send a packet in the buffer ptr or the CBufferList
 *
 * These events is sent to a driver when Lantern needs data to be sent. The
 * driver should send data asynchronously. The driver should buffer data 
 * to be sent as it may receive more data to send.
 */
/*--------------------------------
  ::SendBuffer:
  obt@AhXŎw肳ꂽpPbg𑗏o
--------------------------------*/
void  TLucentWaveLAN::SendBuffer(Ptr thePacket, Size packetSize)
{
	ADD_TRACE_EVENT(kLucentEventSendBuffer, 0, 0);

	NewtonErr err = SendPacket((UChar*)thePacket, nil, packetSize);

	ADD_TRACE_EVENT(kLucentEventSendBuffer, 9, err);
}


/*--------------------------------
  ::SendCBufferList:
  XgŎw肳ꂽpPbg𑗏o
--------------------------------*/
void  TLucentWaveLAN::SendCBufferList(CBufferList* thePacket)
{
	ADD_TRACE_EVENT(kLucentEventSendCBufferList, 0, 0);

	NewtonErr err = SendPacket(nil, thePacket, thePacket->GetSize());

	ADD_TRACE_EVENT(kLucentEventSendCBufferList, 9, err);
}


/*--------------------------------
  ::SendPacket:
  ۂɃpPbg𑗏o֐̖{
--------------------------------*/
NewtonErr TLucentWaveLAN::SendPacket(
	UChar*			buffer,
	CBufferList*	cBufferList,
	ULong			packetSize
)
{
	NewtonErr	err = noErr;

	/* pPbgTCY`FbN */
	XREQUIRE_ACTION( (packetSize <= kPacketTxMaxLength), exit,
					 err = eLANTERN_DriverValueRangeError;);

	/* n[hEFAɃpPbg𗬂 */
	err = NICWritePacket( packetSize, buffer, cBufferList );
	if( err ){
		goto exit;
	}

	/* n[hEFAxőMN */
	err = NICXmit();

  exit:;
	fDriverAPI->PostReply(err);

	return( err );
}


/*--------------------------------
  ::GetDeviceAddress:
--------------------------------*/
void TLucentWaveLAN::GetDeviceAddress(UByte* addr, Size size)
{
	ADD_TRACE_EVENT(kLucentEventGetDeviceAddress, 0, 0);
	
	memcpy( (INT8*)addr, (INT8*)fEthernetAddr,
		    size < sizeof(fEthernetAddr) ? size : sizeof(fEthernetAddr));

	fDriverAPI->PostReply(
		size != sizeof(fEthernetAddr) ? eLANTERN_DriverValueRangeError : noErr);
	
	ADD_TRACE_EVENT(kLucentEventGetDeviceAddress, 9, noErr);
}


/*
 * ύXsv
 * (NICˑ[`̕ŋz)
 */
/*
 * void TLucentWaveLAN::AddMulticastAddress(UChar* addr)
 *
 * Add a multicast address
 *
 * NOTE: The driver is required to maintain a counter for each multicast address.
 *       This allows the same multicast address to be shared by different clients.
 *       The multicast address will be deleted from the card when the counter is
 *       decreased to 0 by DelMulticastAddress().
 */
/*--------------------------------
  ::AddMulticastAddress:
--------------------------------*/
void TLucentWaveLAN::AddMulticastAddress(UChar* addr)
{
	NewtonErr	err = noErr;

	ADD_TRACE_EVENT(kLucentEventAddMulticastAddress, 0, 0);

	err = NICAddDeleteMulticastAddr(addr, true);
	fDriverAPI->PostReply(err);

	ADD_TRACE_EVENT(kLucentEventAddMulticastAddress, 9, err);
}


/*--------------------------------
  ::DelMulticastAddress:
--------------------------------*/
void TLucentWaveLAN::DelMulticastAddress(UChar* addr)
{
	ADD_TRACE_EVENT(kLucentEventDelMulticastAddress, 0, 0);
	
	NewtonErr err = NICAddDeleteMulticastAddr(addr, false);
	fDriverAPI->PostReply(err);

	ADD_TRACE_EVENT(kLucentEventDelMulticastAddress, 9, err);
}


/*--------------------------------
  ::GetLinkIntegrity:
--------------------------------*/
void TLucentWaveLAN::GetLinkIntegrity()
{
	NewtonErr err = noErr;

	ADD_TRACE_EVENT(kLucentEventGetLinkIntegrity, 0, 0);

	Boolean linkIntegrity = NICGetLinkIntegrity();
	fDriverAPI->PostReply(err, 1, linkIntegrity);

	ADD_TRACE_EVENT(kLucentEventGetLinkIntegrity, 9, (ULong) linkIntegrity);
}


/*--------------------------------
  ::SetPromiscuous:
--------------------------------*/
void TLucentWaveLAN::SetPromiscuous(ULong prom)
{
	ADD_TRACE_EVENT(kLucentEventSetPromiscuous, 0, prom);

	NewtonErr err = NICSetPromiscuous(prom);

	fDriverAPI->PostReply(err);

	ADD_TRACE_EVENT(kLucentEventSetPromiscuous, 9, err);
}


/*--------------------------------
  ::GetThroughput:
--------------------------------*/
void TLucentWaveLAN::GetThroughput()
{
	ADD_TRACE_EVENT(kLucentEventGetThroughput, 0, 0);

	fDriverAPI->PostReply( kError_Call_Not_Implemented );

	ADD_TRACE_EVENT(kLucentEventGetThroughput, 9, 0);
}


/*--------------------------------
  ::InitCard:
--------------------------------*/
NewtonErr TLucentWaveLAN::InitCard()
{
	NewtonErr err = noErr;

	/*
	 * PCJ[hC^[tF[X
	 */
	/* PCMCIAoXI/O[hɐݒ肷 */
	fCardSocket->SelectIOInterface();

	/* I/OɃRtBM[VGgԍݒ肷 */
	WriteRegB( ToLittleEndianAddr(fCardConfigBaseAddr), fCardConfigNumber );

	/*
	 * 04/08/2000
	 * X̐ݒł͂܂Ȃ悤D
	 * ĂۂłɕύXƂ肠?
	 */
#if 1	/* 05/20/2001 */
	fCardSocket->SetControl( kCardPortAccess | kCardAutoIOIs16 );
#else
	/*
	 * Set bus control to the following for debugger
	 *		to display 8-bit control registers correctly:
	 * For 16-bit card: set to auto increment addr,
	 *					assembly 32 (2 16-bit accesses),
	 *					Auto size with IOIs16
	 * For 8-bit card:  set to auto increment addr,
	 *					assembly 32 (4 8-bit accesses),
	 *					Auto size with IOIs16 or byte access
	 */
	fCardSocket->SetControl( kCardAssembly32 | kCareAutoIncAddress | kCardAutoIOIs16 );
#endif

	/* dw肷 */
	if( fFlagCard3VAvail == true ){
		fCardSocket->SelectVoltageLevel( kSocketPowerLevelVcc3p3V );
	} else{
		fCardSocket->SelectVoltageLevel( kSocketPowerLevelVcc5V );
	}

	/*
	 * n[hEFA
	 */
	err = NICInit();

	return err;
}


/*--------------------------------
  ::SetConfig:
--------------------------------*/
void  TLucentWaveLAN::SetConfig( ULong  itemID, ULong  argVal, void*  argObj )
{
	NewtonErr	err = noErr;
	INT16		ii;

	/*
	 * - p[^ێϐXV
	 * - XVp[^n[hEFAɂݒ肷
	 */
	switch( itemID ){
	  case CONF_ID_VAL_CHANNEL:
		fOwnChannel = argVal;
		break;

	  case CONF_ID_STR_SSID:
		strncpy( fNetName, (char*)argObj, sizeof(fNetName) - 1 );
		strncpy( fIBSSName, (char*)argObj, sizeof(fIBSSName) - 1 );
		break;

	  case CONF_ID_VAL_MODE:
		fWaveLANMode = argVal;
		break;

	  case CONF_ID_VAL_WEP_ENA:
		fUseWEP = argVal ? FLAG_ON : FLAG_OFF;
		break;

	  case CONF_ID_STR_WEP_KEY:
		if( argVal > WEP_KEY_MAX_LEN ){
			argVal = WEP_KEY_MAX_LEN;
		}
#if 1	/* 11/04/2002 modified */
		for( ii = 0 ; ii < 4 ; ii++ ){
			memcpy( &(fWEPKeys.wi_keys[ii].wi_keydat[0]), argObj, argVal );
			fWEPKeys.wi_keys[ii].wi_keylen = argVal;
		}
#else
		memcpy( &(fWEPKeys.wi_keys[fWEPKeySel].wi_keydat[0]), argObj, argVal );
		fWEPKeys.wi_keys[fWEPKeySel].wi_keylen = argVal;
#endif
		dumpMem( (UINT8*)argObj, argVal );
		goto l_end;
		break;

	  case CONF_ID_VAL_REGIST_OK:
//		fFlagRegistOK = ((argVal == 0) ? FLAG_ON : FLAG_OFF);
		fFlagRegistOK = FLAG_ON;
		break;

	  default:
		break;
	}
	DEB_ASSERT( 0, ("ID = %d, val = %d, obj = %s\n",itemID,argVal,argObj) );

  l_end:;
	fDriverAPI->PostReply( err );
}


/*--------------------------------
  ::GetConfig:
--------------------------------*/
void  TLucentWaveLAN::GetConfig( ULong  itemID )
{
	NewtonErr	err = noErr;
	UINT32		val	= 0;
	Ref			ref	= NILREF;

	switch( itemID ){
	  case CONF_ID_VAL_CHANNEL:
		val = fOwnChannel;
		break;
	  case CONF_ID_STR_SSID:
//		ref = MakeString( &(fNetName[0]) );
		break;
	  case CONF_ID_VAL_MODE:
		val = fWaveLANMode;
		break;
	  default:
		break;
	}

	fDriverAPI->PostReply( err, 2, val, ref );
}




/****************************************************************************
  n[hEFAɈˑ֐
****************************************************************************/


/*--------------------------------
  w_swap:
  16rbglHigh/LowXbv
--------------------------------*/
inline UINT16  w_swap( UINT16  src )
{
	UINT16	dst;

	dst = src << 8;
	dst |= (src >> 8) & 0xFF;

	return( dst );
}


#define		htons(val)		(val)
#define		ntohs(val)		(val)

#define		htole16(val)	(w_swap( (val) ))
#define		le16toh(val)	(w_swap( (val) ))
#define		H_TO_LE16(val)	{(val) = w_swap( (val) );}
#define		LE16_TO_H(val)	{(val) = w_swap( (val) );}


/*--------------------------------
  ::NICReadRegW:
--------------------------------*/
UINT16  TLucentWaveLAN::NICReadRegW( UINT32  offs )
{
	UINT16	val;

	val = fCardSocket->Do16BitRead( fNICBaseAddr + (offs ^ 0x2) );

	return( val );
}


/*--------------------------------
  ::NICWriteRegW:
--------------------------------*/
void  TLucentWaveLAN::NICWriteRegW( UINT32  offs, UINT16  val )
{
	fCardSocket->Do16BitWrite( fNICBaseAddr + (offs ^ 0x2), val );
}


/*--------------------------------
  ::NICCmd:
--------------------------------*/
INT32  TLucentWaveLAN::NICCmd(
	UINT16	cmd,
	UINT16	val
)
{
	INT32	i;
	INT32	s = 0;
	INT32	ret = FALSE;

	/* wait for busy bit to clear */
	for( i = WI_TIMEOUT ; --i >= 0 ; ){
		if( (NICReadRegW( WI_COMMAND ) & WI_CMD_BUSY) == 0 ){
			break;
		}
		Sleep( 1 * kMicroseconds );
	}
	if( i <= 0 ){
		ret = 2;
		goto l_end;
	}

	NICWriteRegW( WI_PARAM0, val );
	NICWriteRegW( WI_PARAM1, 0 );
	NICWriteRegW( WI_PARAM2, 0 );
	NICWriteRegW( WI_COMMAND, cmd );

	if( cmd == WI_CMD_INI ){
		Sleep( 100 * kMilliseconds );
	}

	/* wait for cmd complete bit */
	for( i = WI_TIMEOUT ; --i >= 0 ; ){
		if( (NICReadRegW( WI_EVENT_STAT ) & WI_EV_CMD) != 0 ){
			break;
		}
		Sleep( 1 * kMicroseconds );
	}

	/* Ack the command */
	NICWriteRegW( WI_EVENT_ACK, WI_EV_CMD );

	s = NICReadRegW( WI_STATUS );
	if( (s & WI_STAT_CMD_RESULT) != 0 ){
		ret = 1;
		goto l_end;
	}

	if( i <= 0 ){
		ret = 2;
		goto l_end;
	}

  l_end:;

	return( ret );
}


/*--------------------------------
  ::NICSeek:
--------------------------------*/
INT32  TLucentWaveLAN::NICSeek(
	INT32	id,
	INT32	off,
	INT32	chan
)
{
	INT32	i;
	INT32	selreg;
	INT32	offreg;
	INT32	ret = FALSE;

	switch( chan ){
	  case WI_BAP0:
		selreg	= WI_SEL0;
		offreg	= WI_OFF0;
		break;
	  case WI_BAP1:
		selreg	= WI_SEL1;
		offreg	= WI_OFF1;
		break;
	  default:
		ret = 1;
		goto l_end;
		break;
	}

	NICWriteRegW( selreg, id );
	NICWriteRegW( offreg, off );

	for( i = 0 ; i < WI_TIMEOUT ; i++ ){
		if( !(NICReadRegW( offreg ) & (WI_OFF_BUSY | WI_OFF_ERR)) ){
			break;
		}
		Sleep( 1 * kMicroseconds );
	}
	if( i >= WI_TIMEOUT ){
		ret = 2;
	}

  l_end:;

	return( ret );
}


/*--------------------------------
  ::NICReadRecord:
--------------------------------*/
INT32  TLucentWaveLAN::NICReadRecord( struct wi_ltv_gen*  ltv )
{
	UINT16*				wp;
	INT32				i;
	INT32				len;
	INT32				code;
	INT32				ret = FALSE;
	struct wi_ltv_gen*	oltv;
	struct wi_ltv_gen	p2ltv;

	if( fFirmwareType != FIRMWARE_TYPE_LUCENT ){
		oltv = ltv;

		switch( ltv->wi_type ){
		  case WI_RID_ENCRYPTION:
			p2ltv.wi_type = WI_RID_P2_ENCRYPTION;
			p2ltv.wi_len = 2;
			ltv = &(p2ltv);
			break;

		  case WI_RID_TX_CRYPT_KEY:
			p2ltv.wi_type = WI_RID_P2_TX_CRYPT_KEY;
			p2ltv.wi_len = 2;
			ltv = &(p2ltv);
			break;

		  case WI_RID_ROAMING_MODE:
			if( fFirmwareType == FIRMWARE_TYPE_INTERSIL ){
				break;
			}
			/* not supported */
			ltv->wi_len = 1;
			goto l_end;
			break;

		  case WI_RID_MICROWAVE_OVEN:
			/* not supported */
			ltv->wi_len = 1;
			goto l_end;
			break;

		  default:
			break;
		}
	}

	if( NICCmd( WI_CMD_ACCESS | WI_ACCESS_READ, ltv->wi_type ) ){
		ret = 1;
		goto l_end;
	}

	if( NICSeek( ltv->wi_type, 0, WI_BAP1 ) ){
		ret = 2;
		goto l_end;
	}

	len = NICReadRegW( WI_DATA1 );
	if( len > ltv->wi_len ){
		ret = 3;
		goto l_end;
	}

	code = NICReadRegW( WI_DATA1 );
	if( code != ltv->wi_type ){
		ret = 4;
		goto l_end;
	}

	ltv->wi_len		= len;
	ltv->wi_type	= code;

	/* f[^ǂݏo */
	wp = &(ltv->wi_val);
	for( i = 0 ; i < ltv->wi_len - 1 ; i++ ){
		wp[i] = w_swap( NICReadRegW( WI_DATA1 ) );
	}

	if( fFirmwareType != FIRMWARE_TYPE_LUCENT ){
		INT32	v;

		switch( oltv->wi_type ){
		  case WI_RID_TX_RATE:
		  case WI_RID_CUR_TX_RATE:
			switch( le16toh( ltv->wi_val ) ){
			  case 1:	v = 1;	break;
			  case 2:	v = 2;	break;
			  case 3:	v = 6;	break;
			  case 4:	v = 5;	break;
			  case 7:	v = 7;	break;
			  case 8:	v = 11;	break;
			  case 15:	v = 3;	break;
			  default:
				v = 0x100 + le16toh( ltv->wi_val );
				break;
			}
			oltv->wi_val = htole16( v );
			break;

		  case WI_RID_ENCRYPTION:
			oltv->wi_len = 2;
			if( (le16toh( ltv->wi_val ) & 0x01) != 0 ){
				oltv->wi_val = htole16( 1 );
			} else{
				oltv->wi_val = htole16( 0 );
			}
			break;

		  case WI_RID_TX_CRYPT_KEY:
			oltv->wi_len = 2;
			oltv->wi_val = ltv->wi_val;
			break;

		  case WI_RID_AUTH_CNTL:
			oltv->wi_len = 2;
			if( (le16toh( ltv->wi_val ) & 0x01) != 0 ){
				oltv->wi_val = htole16( 1 );
			} else{
				if( (le16toh(ltv->wi_val) & 0x02) != 0 ){
					oltv->wi_val = htole16( 2 );
				}
			}
			break;
		}
	}

  l_end:;
	return( ret );
}


/*--------------------------------
  ::NICWriteRecord:
--------------------------------*/
INT32  TLucentWaveLAN::NICWriteRecord( struct wi_ltv_gen*  ltv )
{
	UINT16*				wp;
	INT32				i;
	struct wi_ltv_gen	p2ltv;
	INT32				ret = FALSE;

	if( fFirmwareType != FIRMWARE_TYPE_LUCENT ){
		INT32	v;

		switch( ltv->wi_type ){
		  case WI_RID_TX_RATE:
			p2ltv.wi_type = WI_RID_TX_RATE;
			p2ltv.wi_len = 2;
			switch ( le16toh( ltv->wi_val ) ){
			  case 1:	v = 1;	break;
			  case 2:	v = 2;	break;
			  case 3:	v = 15; break;
			  case 5:	v = 4;	break;
			  case 6:	v = 3;	break;
			  case 7:	v = 7;	break;
			  case 11:	v = 8;	break;
			  default:
				ret = 1;
				goto l_end;
				break;
			}
			p2ltv.wi_val = htole16( v );
			ltv = &(p2ltv);
			break;

		  case WI_RID_ENCRYPTION:
			p2ltv.wi_type = WI_RID_P2_ENCRYPTION;
			p2ltv.wi_len = 2;
			if( le16toh( ltv->wi_val ) ){
				p2ltv.wi_val =
					htole16( PRIVACY_INVOKED | EXCLUDE_UNENCRYPTED );
			} else{
				p2ltv.wi_val =
				    htole16( HOST_ENCRYPT | HOST_DECRYPT );
			}
			ltv = &(p2ltv);
			break;

		  case WI_RID_TX_CRYPT_KEY:
			p2ltv.wi_type = WI_RID_P2_TX_CRYPT_KEY;
			p2ltv.wi_len = 2;
			p2ltv.wi_val = ltv->wi_val;
			ltv = &(p2ltv);
			break;

		  case WI_RID_DEFLT_CRYPT_KEYS:
		    do {
				INT32				error;
				INT32				keylen;
				struct wi_ltv_str	ws;
				struct wi_ltv_keys*	wk = (struct wi_ltv_keys*)ltv;

				keylen = wk->wi_keys[ fWEPKeySel ].wi_keylen;

				for( i = 0 ; i < 4 ; i++ ){
					memset( &ws, 0, sizeof(ws) );
					ws.wi_len = (keylen > 5) ? 8 : 4;
					ws.wi_type = WI_RID_P2_CRYPT_KEY0 + i;
					memcpy( ws.wi_str, &(wk->wi_keys[i].wi_keydat), keylen );
					error =	NICWriteRecord( (struct wi_ltv_gen *)&ws );
					if( error != 0 ){
						ret = error;
						goto l_end;
					}
				}
				goto l_end;
		    } while( 0 );
			break;

		  case WI_RID_AUTH_CNTL:
			p2ltv.wi_type = WI_RID_AUTH_CNTL;
			p2ltv.wi_len = 2;
			if( le16toh( ltv->wi_val ) == 1 ){
				p2ltv.wi_val = htole16( 0x01 );
			} else{
				if( le16toh( ltv->wi_val ) == 2 ){
					p2ltv.wi_val = htole16( 0x02 );
				}
			}
			ltv = &(p2ltv);
			break;

		  case WI_RID_ROAMING_MODE:
			if( fFirmwareType == FIRMWARE_TYPE_INTERSIL ){
				break;
			}
			/* not supported */
			goto l_end;
			break;

		  case WI_RID_MICROWAVE_OVEN:
			/* not supported */
			goto l_end;
			break;

		  default:
			break;
		}
	}

	if( NICSeek( ltv->wi_type, 0, WI_BAP1 ) ){
		ret = 1;
		goto l_end;
	}

	NICWriteRegW( WI_DATA1, ltv->wi_len );
	NICWriteRegW( WI_DATA1, ltv->wi_type );

	wp = (UINT16*)&(ltv->wi_val);
	for( i = 0 ; i < ltv->wi_len - 1 ; i++ ){
		NICWriteRegW( WI_DATA1, w_swap( wp[i] ) );
	}

	if( NICCmd( WI_CMD_ACCESS | WI_ACCESS_WRITE, ltv->wi_type ) ){
		ret = 2;
		goto l_end;
	}

  l_end:;

	return( ret );
}


/*--------------------------------
  ::NICSetVal:
--------------------------------*/
void  TLucentWaveLAN::NICSetVal( UINT16  rec_no, UINT16  val )
{
	struct wi_ltv_gen	g;

	g.wi_len 	= (1 + 1);
	g.wi_type	= rec_no;
	g.wi_val	= htole16( val );

	NICWriteRecord( &g );
}


/*--------------------------------
  ::NICGetVal:
--------------------------------*/
UINT16  TLucentWaveLAN::NICGetVal( UINT16  rec_no )
{
	struct wi_ltv_gen	g;
	UINT16				val;

	memset( &g, 0, sizeof(g) );
	g.wi_len 	= (1 + 1);
	g.wi_type	= rec_no;

	NICReadRecord( &g );
	val = le16toh( g.wi_val );

	return( val );
}


/*--------------------------------
  ::NICSetStr:
--------------------------------*/
void  TLucentWaveLAN::NICSetStr( UINT16  rec_no, UINT8*  pStr )
{
	struct wi_ltv_str	s;
	INT32				len;
	INT32				ll;

	ll = strlen( (INT8*)pStr );
	len = (ll + 1) & ~0x1;
	memset( (void*)&s, 0, sizeof(s) );
	s.wi_len 	= (len / 2) + 2;
	s.wi_type	= rec_no;
	s.wi_str[0] = htole16( ll );
	memcpy( (UINT8*)&(s.wi_str[1]), pStr, ll );

	NICWriteRecord( (struct wi_ltv_gen*)&s );
}


/*--------------------------------
  ::NICReadData:
--------------------------------*/
INT32  TLucentWaveLAN::NICReadData(
	INT32	id,
	INT32	off,
	void*	buf,
	INT32	len
)
{
	INT32		i;
	UINT16*		wp;
	INT32		ret = FALSE;

	if( NICSeek( id, off, WI_BAP1 ) ){
		ret = 1;
		goto l_end;
	}

	wp = (UINT16*)buf;
	for( i = 0 ; i < (len / 2) ; i++ ){
		wp[i] = w_swap( NICReadRegW( WI_DATA1 ) );
	}

  l_end:;

	return( ret );
}


/*--------------------------------
  ::NICWriteData:
--------------------------------*/
INT32  TLucentWaveLAN::NICWriteData(
	INT32	id,
	INT32	off,
	void*	buf,
	INT32	len
)
{
	INT32		i;
	UINT16*		wp;
	INT32		ret = FALSE;

#ifdef FIX_HERMES_BUG
  again:;
#endif

	if( NICSeek( id, off, WI_BAP0 ) ){
		ret = 1;
		goto l_end;
	}

	wp = (UINT16*)buf;
	for( i = 0 ; i < (len / 2) ; i++ ){
		NICWriteRegW( WI_DATA0, w_swap( wp[i] ) );
	}

#ifdef FIX_HERMES_BUG
	NICWriteRegW( WI_DATA0, 0x1234 );
	NICWriteRegW( WI_DATA0, 0x5678 );

	if( NICSeek( id, off + len, WI_BAP0 ) ){
		ret = 2;
		goto l_end;
	}

	if( (NICReadRegW( WI_DATA0 ) != 0x1234) ||
			(NICReadRegW( WI_DATA0 ) != 0x5678) ){
		goto again;
	}
#endif

  l_end:;

	return( ret );
}


/*--------------------------------
  ::NICReset:
--------------------------------*/
INT32  TLucentWaveLAN::NICReset( void )
{
	INT32	i;
	INT32	ret = FALSE;

	for( i = 5 ; --i >= 0 ;  ){
		Sleep( 20 * kMilliseconds );
		if( NICCmd( WI_CMD_INI, 0 ) == 0 ){
			break;
		}
	}
	if( i < 0 ){
		ret = 1;
		goto l_end;
	}

	NICWriteRegW( WI_INT_EN, 0x0000 );
	NICWriteRegW( WI_EVENT_ACK, 0xFFFF );

#if 1	/* 10/26/2002 modified */
	NICSetVal( WI_RID_TICK_TIME, 0 );
#else
	NICSetVal( WI_RID_TICK_TIME, 8 );
#endif

  l_end:;

	return( ret );
}


/*--------------------------------
  ::NICAllocNICMem:
--------------------------------*/
INT32  TLucentWaveLAN::NICAllocNICMem(
	INT32	len,
	INT32*	pID
)
{
	INT32	ret = FALSE;
	INT32	i;

	if( NICCmd( WI_CMD_ALLOC_MEM, len ) ){
		ret = 1;
		goto l_exit;
	}

	for( i = 0 ; i < WI_TIMEOUT ; i++ ){
		if( (NICReadRegW( WI_EVENT_STAT ) & WI_EV_ALLOC) != 0 ){
			break;
		}
		Sleep( 1 * kMicroseconds );
	}
	if( i >= WI_TIMEOUT ){
		ret = 2;
		goto l_exit;
	}

	*pID = NICReadRegW( WI_ALLOC_FID );
	NICWriteRegW( WI_EVENT_ACK, WI_EV_ALLOC );

#if 0	/* 10/26/2002 c.o. */
	if( NICSeek( *pID, 0, WI_BAP0 ) ){
		ret = 3;
		goto l_exit;
	}

	/* obt@[߂ */
	for( i = 0 ; i < (len / 2) ; i++ ){
		NICWriteRegW( WI_DATA0, 0 );
	}
#endif

  l_exit:;

	return( ret );
}


/*--------------------------------
  ::NICUpdateStatus:
--------------------------------*/
INT32  TLucentWaveLAN::NICUpdateStatus()
{
	struct wi_ltv_gen	gen;
	UINT16				id;
	UINT32*				lp;
	INT32				i;
	INT32				len;
	UINT16				t;
	INT32				ret = FALSE;

	id = NICReadRegW( WI_INFO_FID );

	NICReadData( id, 0, &gen, 4 );

	if( gen.wi_type != WI_INFO_COUNTERS ){
		ret = 1;
		goto l_end;
	}

	len = ( (gen.wi_len - 1) < (sizeof(fCounters) / sizeof(UINT32)) ) ?
				(gen.wi_len - 1) : (sizeof(fCounters) / sizeof(UINT32));
	lp = (UINT32*)&fCounters;

	for( i = 0 ; i < len ; i++ ){
		t = NICReadRegW( WI_DATA1 );

#ifdef FIX_HERMES_STATS_BUG
		if( t > 0xF000 ){
			t = ~t & 0xFFFF;
		}
#endif
		lp[i] += t;
	}

  l_end:;
	return( ret );
}


/*
 * t@[EFAʏe[u
 */
const struct wi_card_ident	zrTabCardIdent[] = {
	/* CARD_ID	CARD_NAME	FIRM_TYPE */
	{ WI_NIC_LUCENT_ID,				WI_NIC_LUCENT_STR,		FIRMWARE_TYPE_LUCENT },
	{ WI_NIC_SONY_ID,				WI_NIC_SONY_STR,		FIRMWARE_TYPE_LUCENT },
	{ WI_NIC_LUCENT_EMB_ID,			WI_NIC_LUCENT_EMB_STR,	FIRMWARE_TYPE_LUCENT },
	{ WI_NIC_EVB2_ID,				WI_NIC_EVB2_STR,		FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_HWB3763_ID,			WI_NIC_HWB3763_STR,		FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_HWB3163_ID,			WI_NIC_HWB3163_STR,		FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_HWB3163B_ID,			WI_NIC_HWB3163B_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_EVB3_ID,				WI_NIC_EVB3_STR,		FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_HWB1153_ID,			WI_NIC_HWB1153_STR,		FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_P2_SST_ID,				WI_NIC_P2_SST_STR,		FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_EVB2_SST_ID,			WI_NIC_EVB2_SST_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_EVA_ID,			WI_NIC_3842_EVA_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_PCMCIA_AMD_ID,	WI_NIC_3842_PCMCIA_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_PCMCIA_SST_ID,	WI_NIC_3842_PCMCIA_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_PCMCIA_ATM_ID,	WI_NIC_3842_PCMCIA_STR,	FIRMWARE_TYPE_INTERSIL },
#if 0
	{ WI_NIC_3842_MINI_AMD_ID,		WI_NIC_3842_MINI_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_MINI_SST_ID,		WI_NIC_3842_MINI_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_MINI_ATM_ID,		WI_NIC_3842_MINI_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_PCI_AMD_ID,		WI_NIC_3842_PCI_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_PCI_SST_ID,		WI_NIC_3842_PCI_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_3842_PCI_ATM_ID,		WI_NIC_3842_PCI_STR,	FIRMWARE_TYPE_INTERSIL },
#endif
	{ WI_NIC_P3_PCMCIA_AMD_ID,		WI_NIC_P3_PCMCIA_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_P3_PCMCIA_SST_ID,		WI_NIC_P3_PCMCIA_STR,	FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_P3_MINI_AMD_ID,		WI_NIC_P3_MINI_STR,		FIRMWARE_TYPE_INTERSIL },
	{ WI_NIC_P3_MINI_SST_ID,		WI_NIC_P3_MINI_STR,		FIRMWARE_TYPE_INTERSIL },
	{ 0,	NULL,	0 },
};


/*--------------------------------
  ::NICGetID:
--------------------------------*/
void  TLucentWaveLAN::NICGetID( void )
{
	struct wi_ltv_ver				ver;
	const struct wi_card_ident*		pID;

	/* ʏǂݎ */
	memset( &ver, 0, sizeof(ver) );
	ver.wi_type = WI_RID_CARD_ID;
	ver.wi_len = 5;
	NICReadRecord( (struct wi_ltv_gen*)&ver );

	/* ʏe[uƓ˂킹 */
	fFirmwareType = FIRMWARE_TYPE_NONE;
	for( pID = zrTabCardIdent ; pID->card_name != NULL ; pID++ ){
		if( le16toh( ver.wi_ver[0] ) == pID->card_id ){
			DEB_ASSERT( 0, ("card name = %s\n",pID->card_name) );
			fFirmwareType = pID->firm_type;
			break;
		}
	}
	if( fFirmwareType == FIRMWARE_TYPE_NONE ){
		if( (le16toh( ver.wi_ver[0] ) & 0x8000) != 0 ){
			DEB_ASSERT( 0, ("Unknown PRISM2 chip") );
			fFirmwareType = FIRMWARE_TYPE_INTERSIL;
		} else{
			DEB_ASSERT( 0, ("Unknown Lucent chip") );
			fFirmwareType = FIRMWARE_TYPE_LUCENT;
		}
	}

	/*
	 * PRISMn̂Ƃʂ
	 */
	if( fFirmwareType != FIRMWARE_TYPE_LUCENT ){
		memset( &ver, 0, sizeof(ver) );
		ver.wi_type = WI_RID_PRI_IDENTITY;
		ver.wi_len = 5;
		NICReadRecord( (struct wi_ltv_gen*)&ver );
		LE16_TO_H( ver.wi_ver[1] );
		LE16_TO_H( ver.wi_ver[2] );
		LE16_TO_H( ver.wi_ver[3] );
		fFirmwareVerPrimary =
			(ver.wi_ver[2] * 10000) + (ver.wi_ver[3] * 100) + ver.wi_ver[1];
	}

	/*
	 * stationt@[EFÃo[W擾
	 */
	memset( &ver, 0, sizeof(ver) );
	ver.wi_type = WI_RID_STA_IDENTITY;
	ver.wi_len = 5;
	NICReadRecord( (struct wi_ltv_gen*)&ver );
	LE16_TO_H( ver.wi_ver[1] );
	LE16_TO_H( ver.wi_ver[2] );
	LE16_TO_H( ver.wi_ver[3] );
	fFirmwareVerStation =
			(ver.wi_ver[2] * 10000) + (ver.wi_ver[3] * 100) + ver.wi_ver[1];
	if( fFirmwareType == FIRMWARE_TYPE_INTERSIL ){
		struct wi_ltv_str	sver;
		INT8*				bp;

		switch( fFirmwareVerStation ){
		  case 10102:
		  case 20102:
			memset( &sver, 0, sizeof(sver) );
			sver.wi_type = WI_RID_SYMBOL_IDENTITY;
			sver.wi_len = 7;
			if( NICReadRecord( (struct wi_ltv_gen*)&sver ) == 0 ){
				bp = (INT8*)sver.wi_str;
				if( (bp[0] >= 'A') &&
						(bp[2] == '.') && (bp[5] == '-') &&	(bp[8] == '\0') ){
					fFirmwareType = FIRMWARE_TYPE_SYMBOL;
					fFirmwareVerStation =
						((bp[1] - '0') * 10000) + ((bp[3] - '0') * 1000) +
						((bp[4] - '0') * 100) + ((bp[6] - '0') * 10) + (bp[7] - '0');
				}
			}
			break;
		  default:
			break;
		}
	}

	DEB_ASSERT( 0, ("%s Firmware: ",
					 (fFirmwareType == FIRMWARE_TYPE_LUCENT) ? "Lucent" :
					 (fFirmwareType == FIRMWARE_TYPE_SYMBOL) ? "Symbol" : "Intersil") );
	if( fFirmwareType != FIRMWARE_TYPE_LUCENT ){
		DEB_ASSERT( 0, ("Primary (%d.%d.%d), ",
						 fFirmwareVerPrimary / 10000,
						 (fFirmwareVerPrimary % 10000) / 100,
						 (fFirmwareVerPrimary % 100)) );
	}
	DEB_ASSERT( 0, ("Station (%d.%d.%d)\n",
					 fFirmwareVerStation / 10000,
					 (fFirmwareVerStation % 10000) / 100,
					 (fFirmwareVerStation % 100)) );
}


/*--------------------------------
  ::TimerProcBeat:
--------------------------------*/
void  TLucentWaveLAN::TimerProcBeat( void )
{
	NewtonErr	err = noErr;

	if( fStatus & DRV_STAT_CARD_POWER_ON ){
		NICCmd( WI_CMD_INQUIRE, WI_INFO_COUNTERS );

		/* ̃^XNgCxg󂯎悤Ƀ|Xg */
		fFlagBeatTimer	= true;
		fTimeBeat		= fTimeBeat + TTime( TC_INQUIRE, kMilliseconds);
		fDriverAPI->PostLocalEvent( &fTimeBeat, kWaveLANEventBeatTimer );
	} else{
		fFlagBeatTimer = false;
	}
}


/*--------------------------------
  ::NICInitVars:
--------------------------------*/
void  TLucentWaveLAN::NICInitVars( void )
{
	DEB_ASSERT( 60, ("NICInitVars()\n") );

//	fFlagRegistOK	= FLAG_OFF;
	fFlagRegistOK	= FLAG_ON;
	fWaveLANMode 	= WVLAN_DEFAULT_MODE;

	fPortNum	= WI_DEFAULT_PORT;			/* wi_portnum */
	fPortType	= WI_PORTTYPE_BSS;
	fApDensity	= WI_DEFAULT_AP_DENSITY;	/* wi_ap_density */
	fRTSThresh	= WI_DEFAULT_RTS_THRESH;	/* wi_rts_thresh */
	fTxRate		= WI_DEFAULT_TX_RATE;		/* wi_tx_rate */
	fMaxDataLen	= WI_DEFAULT_DATALEN;		/* wi_max_data_len */
	fCreateIBSS	= WI_DEFAULT_CREATE_IBSS;	/* wi_create_ibss */
	fPMEnabled	= WI_DEFAULT_PM_ENABLED;	/* wi_pm_enabled */
	fMaxSleep	= WI_DEFAULT_MAX_SLEEP;		/* wi_max_sleep */
	fOwnChannel	= WI_DEFAULT_CHAN;			/* wi_channel */
	fRoaming	= WI_DEFAULT_ROAMING;		/* wi_roaming */
	fAuthType	= WI_DEFAULT_AUTHTYPE;		/* wi_authtype */

	fHasWEP		= FLAG_OFF;
	fUseWEP		= FLAG_OFF;
	fWEPKeySel	= 0;
	memset( &fWEPKeys, 0, sizeof(fWEPKeys) );

	memset( fNodeName, 0, sizeof(fNodeName) );		/* wi_node_name */
	memcpy( fNodeName, WI_DEFAULT_NODENAME, sizeof(WI_DEFAULT_NODENAME) - 1 );

	memset( fNetName, 0, sizeof(fNetName) );		/* wi_net_name */
	memcpy( fNetName, WI_DEFAULT_NETNAME, sizeof(WI_DEFAULT_NETNAME) - 1 );

	memset( fIBSSName, 0, sizeof(fIBSSName) );		/* wi_ibss_name */
	memcpy( fIBSSName, WI_DEFAULT_IBSS, sizeof(WI_DEFAULT_IBSS) - 1 );

	fFirmwareType = FIRMWARE_TYPE_NONE;
}


/*
 * 05/23/1999  Ԃ΂: x1 --> x10
 */
/*
 * `bvZbgsȂƂ́CŒł200[usec]҂ƁC
 * ƃRg[̐ɂ̂ŁCD
 */
#define		TC_WAIT_RESET	(10 * kMilliseconds)


/*--------------------------------
  ::NICInit:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICInit( void )
{
	UINT16			val;
	NewtonErr		err = noErr;
	VOLATILE(err);

	ADD_TRACE_EVENT(kLucentEventNICInit, 0, 0);

	DEB_ASSERT( 60, ("NICInit()\n") );

	memset( &fCounters, 0, sizeof(fCounters) );

	/*********************************/
	/*      n[hEFA       */
	/*********************************/

	NICWriteRegW( WI_INT_EN, 0x0000 );
	NICWriteRegW( WI_EVENT_ACK, 0xFFFF );

	/* NICZbg */
	NICReset();

	/* J[hʏǂݎ */
	NICGetID();

	/* ҂܂傤 */
	Sleep( TC_WAIT_RESET );

	switch( fWaveLANMode ){
	  case WVLAN_MODE_INFRA:
		fPortType	= WI_PORTTYPE_BSS;
		fCreateIBSS	= FLAG_OFF;
		DEB_ASSERT( 20, ("mode = infrastructure\n") );
		break;
	  case WVLAN_MODE_ADHOC:
		if( fFirmwareType != FIRMWARE_TYPE_LUCENT ){
			fPortType	= WI_PORTTYPE_PRISM_IBSS;
		} else{
			fPortType	= WI_PORTTYPE_BSS;
			fCreateIBSS	= FLAG_ON;
		}
		DEB_ASSERT( 20, ("mode = ad-hoc\n") );
		break;
	  case WVLAN_MODE_ADHOC_DEMO:
		fPortType	= WI_PORTTYPE_ADHOC;
		fCreateIBSS	= FLAG_OFF;
		DEB_ASSERT( 20, ("mode = ad-hoc (old)\n") );
		break;
	  default:
		break;
	}

	/* őf[^ */
	NICSetVal( WI_RID_MAX_DATALEN, fMaxDataLen );

	/* IBSS/֎~ ??? */
	if( fFirmwareType != FIRMWARE_TYPE_INTERSIL ){
		NICSetVal( WI_RID_CREATE_IBSS, fCreateIBSS );
	}

	/* |[gʂݒ肷 */
	NICSetVal( WI_RID_PORTTYPE, fPortType );

	/* RTS/CTSXbVhݒ肷 */
	NICSetVal( WI_RID_RTS_THRESH, fRTSThresh );

	/* M[gݒ肷 */
	NICSetVal( WI_RID_TX_RATE, fTxRate );

	/* ANZX|CgfVeB ??? */
	NICSetVal( WI_RID_SYSTEM_SCALE, fApDensity );

	/* p[}l[Wg enable/disable */
	NICSetVal( WI_RID_PM_ENABLED, fPMEnabled );

	/* p[}l[Wg@őX[v ??? */
	NICSetVal( WI_RID_MAX_SLEEP, fMaxSleep );

	/* [~O */
	NICSetVal( WI_RID_ROAMING_MODE, fRoaming );

#if 0
	/* p[}l[Wg ǂ? */
#endif

	/* IBSS */
	NICSetStr( WI_RID_OWN_SSID, (UINT8*)fIBSSName );
	DEB_ASSERT( 60, ("IBSS Name = %s\n",fIBSSName) );

	/* lbg[N */
	NICSetStr( WI_RID_DESIRED_SSID, (UINT8*)fNetName );
	DEB_ASSERT( 60, ("Network Name = %s\n",fNetName) );

	/* Xe[V */
	NICSetStr( WI_RID_NODENAME, (UINT8*)fNodeName );

	/*
	 * ftHg̎g`lǂݏo.
	 *
	 * `lԍ̓J[hʂ鍑ɂĈႤ̂
	 * n[hR[fBOŃftHgl߂Ă͂Ȃ.
	 */
	val = NICGetVal( WI_RID_OWN_CHNL );
	DEB_ASSERT( 20, ("default channel = %d\n",val) );

	/*
	 * L`lꗗ
	 *  USA(FCC):     01`11 ch
	 *  Europe(ETSI): 01`13 ch
	 *  France:       10`13 ch
	 *  Japan:        01`14 ch
	 */
	NICSetVal( WI_RID_OWN_CHNL, fOwnChannel );

	/*
	 * WEPÍ\ǂ`FbN
	 */
	fHasWEP = NICGetVal( WI_RID_WEP_AVAIL );
	DEB_ASSERT( 20, ("WEP support = %d\n",fHasWEP) );

	DEB_ASSERT( 0, ("Registration = %d\n",fFlagRegistOK) );

	/*
	 * WEPݒ肷
	 */
	if( fFlagRegistOK && fHasWEP ){
		NICSetVal( WI_RID_ENCRYPTION, fUseWEP );
		NICSetVal( WI_RID_TX_CRYPT_KEY, fWEPKeySel );

		fWEPKeys.wi_len 	= (sizeof(fWEPKeys) / 2) + 1;
		fWEPKeys.wi_type	= WI_RID_DEFLT_CRYPT_KEYS;
		NICWriteRecord( (struct wi_ltv_gen*)&(fWEPKeys) );

		if( (fFirmwareType != FIRMWARE_TYPE_LUCENT) && fUseWEP ){
			if( (fFirmwareType == FIRMWARE_TYPE_INTERSIL) &&
								(fFirmwareVerStation < 802) ){
				NICSetVal( WI_RID_PROMISC, FLAG_ON );
			}
			NICSetVal( WI_RID_AUTH_CNTL, fAuthType );
		}
	}

	/*
	 * MACAhXݒ肷
	 */
	do {
		struct wi_ltv_macaddr	mac;
		INT32					ii;

		memset( &mac, 0, sizeof(mac) );
		mac.wi_type	= WI_RID_MAC_NODE;
		mac.wi_len	= (kPacketAddrSize / 2) + 1;
		NICReadRecord( (struct wi_ltv_gen*)&mac );

		memcpy( (UINT8*)fEthernetAddr, (UINT8*)mac.wi_mac_addr, kPacketAddrSize );

		DEB_ASSERT( 20, ("MAC address = ") );
		for( ii = 0 ; ii < kPacketAddrSize ; ii++ ){
			DEB_ASSERT( 20, ("%02X ",fEthernetAddr[ii]) );
		}
		DEB_ASSERT( 20, ("\n") );
	} while( 0 );

	/* SM[hł邩ǂݒ肷 */
	NICSetVal( WI_RID_PROMISC, 0 );

	/* }`LXgAhXݒ肷 */
	NICSetMulti();

	/********************************************/
	/* ̎_ł́CM͂܂disable    */
	/********************************************/

  l_exit:;
	return( err );
}


/*--------------------------------
  ::NICEnable:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICEnable()
{
	INT32		id;
	NewtonErr	err = noErr;

	/* start timer events */
	/*
	 * "inquire"Ƃ[`60b炢̈ŌĂяo悤
	 * ݒ肵Ă悤D
	 */
	/* dɃ^C}NȂ悤ɂĂ */
	if( fFlagBeatTimer == false ){
		/* ̃^XNgCxg󂯎悤Ƀ|Xg */
		fFlagBeatTimer	= true;
		fTimeBeat		= GetGlobalTime() + TTime(TC_INQUIRE, kMilliseconds);
		fDriverAPI->PostLocalEvent( &fTimeBeat, kWaveLANEventBeatTimer );
	}

	/* Xe[^XNA */

	/* w肳ꂽ|[gLɂ */
	NICCmd( WI_CMD_ENABLE | fPortNum, 0 );

	/* obt@mۂ: Mobt@ */
	if( NICAllocNICMem( 1518 + sizeof(struct wi_frame) + 8, &id ) ){
		err = kError_No_Memory;
		goto l_end;
	}
	fIDTxBuf = id;		/* mۂMobt@IDo */

	/* 荞݂Lɂ*/
	NICWriteRegW( WI_INT_EN, WI_INTRS );

  l_end:;
	return( err );
}


/*--------------------------------
  ::NICDisable:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICDisable()
{
	NICWriteRegW( WI_INT_EN, 0x0000 );
	NICCmd( WI_CMD_DISABLE | fPortNum, 0 );

	/* stop timer events */
	fFlagBeatTimer = false;

	return( noErr );
}


/*--------------------------------
  ::NICInterrupt:
  荞݃nh
--------------------------------*/
void  TLucentWaveLAN::NICInterrupt()
{
	UINT16	stat;
	Boolean	flagTx = false;
	Boolean	flagRx;

	DEB_ASSERT( 80, ("NICInterrupt() ") );

	/* 荞݂֎~ */
	NICWriteRegW( WI_INT_EN, 0x0000 );

  l_top:;
	flagRx = false;

	stat = NICReadRegW( WI_EVENT_STAT );
	NICWriteRegW( WI_EVENT_ACK, ~WI_INTRS );

	if( stat & WI_EV_RX ){
		NICRxInt();
		NICWriteRegW( WI_EVENT_ACK, WI_EV_RX );
		flagRx = true;

		DEB_ASSERT( 80, ("1 ") );
	}

	if( stat & WI_EV_TX ){
		NICTxInt( stat );
		flagTx = true;
		NICWriteRegW( WI_EVENT_ACK, WI_EV_TX );

		DEB_ASSERT( 80, ("2 ") );
	}

	if( stat & WI_EV_ALLOC ){
		INT32	id;

		id = NICReadRegW( WI_ALLOC_FID );
		NICWriteRegW( WI_EVENT_ACK, WI_EV_ALLOC );
		if( id == fIDTxBuf ){
			NICTxInt( stat );
			flagTx = true;
		}

		DEB_ASSERT( 80, ("3 ") );
	}

	if( stat & WI_EV_INFO ){
		NICUpdateStatus();
		NICWriteRegW( WI_EVENT_ACK, WI_EV_INFO );

		DEB_ASSERT( 80, ("4 ") );
	}

	if( stat & WI_EV_TX_EXC ){
		NICTxInt( stat );
		flagTx = true;
		NICWriteRegW( WI_EVENT_ACK, WI_EV_TX_EXC );

		DEB_ASSERT( 80, ("5 ") );
	}

	if( stat & WI_EV_INFO_DROP ){
		NICWriteRegW( WI_EVENT_ACK, WI_EV_INFO_DROP );

		DEB_ASSERT( 80, ("6 ") );
	}

	if( flagRx == true ){
		goto l_top;
	}

	/* Re-enable interrupts. */
	NICWriteRegW( WI_INT_EN, WI_INTRS );

	DEB_ASSERT( 80, ("\n") );

#if (TX_PKT_NUM > 1)
	if( flagTx == true ){
		/*
		 * ۗĂpPbg邩Ȃ̂, đM݂
		 */
		 NICXmit();
	}
#endif
}


enum {
	ETHER_TYPE_IP	= 0x0800,
	ETHER_TYPE_ARP	= 0x0806
};


#define	RX_BUFF_LEN		(1600)
#define	MAX_RCV_LEN		(RX_BUFF_LEN - 0x20)


/*--------------------------------
  ::NICRxInt:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICRxInt()
{
	NewtonErr			err		= noErr;
	INT32				id;
	struct wi_frame		rx_frame;
	Ptr					pPkt	= NULL;
	TPacketHeader*		pHdr;
	INT32				pktlen;

	id = NICReadRegW( WI_RX_FID );

	/* ܂ŏɃt[wb_ǂݏo */
	if( NICReadData( id, 0, (void*)&rx_frame, sizeof(rx_frame) ) ){
		DEB_ASSERT( 50, ("201 ") );
		goto l_exit;
	}

#if 0	/* for debug */
	dumpMem( (UINT8*)&rx_frame, sizeof(rx_frame) );
#endif

	/* Xe[^X`FbN */
	if( (le16toh( rx_frame.wi_status ) & WI_STAT_ERRSTAT) != 0 ){
		DEB_ASSERT( 50, ("202 ") );
		goto l_exit;
	}

	/* Lantern KitpPbgobt@炤Dő咷Ŋmۂ */
	pPkt = fDriverAPI->NewPacketPtr( RX_BUFF_LEN );
	if( pPkt == nil ){
		goto l_exit;
	}
	pHdr = (TPacketHeader*)pPkt;

	/*
	 * 05/04/2002
	 * Mac OS 9.x, Mac OS X ̂ǂCAppleTalk̃t[
	 * "wi_status" == WI_STAT_1042 ƂđoĂ悤D
	 * ŁC"wi_dat_len"ɐlݒ肳ĂȂ炵
	 * ̂܂ܐK̃WbNŏ悤Ƃƃt[
	 * ܂̍ȂlɂȂĂ܂CʐMłȂD
	 *
	 * IP,ARPȊO802.3`֐U蕪ď΁CƂ肠
	 * ʐMł̂ŁCbƂĂĂD
	 * Newtonł͎ITCP/IPAppleTalkȂ̂
	 * 炭ŖȂ낤D
	 */
	switch( ntohs( rx_frame.wi_type ) ){
	  case ETHER_TYPE_IP:
	  case ETHER_TYPE_ARP:
		break;
	  default:
#if 1	/* 03/09/2003  c.o.: test */
		goto l_802_3;
#endif
		break;
	}

	if( (le16toh( rx_frame.wi_status ) == WI_STAT_1042) ||
			(le16toh( rx_frame.wi_status ) == WI_STAT_TUNNEL) ||
			(le16toh( rx_frame.wi_status ) == WI_STAT_WMP_MSG) ){
		/*************** 802.11`?? *******************/

		/* pPbg`FbN */
		pktlen = le16toh( rx_frame.wi_dat_len ) + WI_SNAPHDR_LEN;
#if 1	/* 10/26/2002 modified */
		if( pktlen > kPacketRxMaxLength ){
#else
		if( pktlen > MAX_RCV_LEN ){
#endif
			err = eLANTERN_DriverValueRangeError;
			DEB_ASSERT( 50, ("203 ") );
			goto l_exit;
		}

		/* Ethernett[wb_obt@Ɉڂ */
		memcpy( (UINT8*)pHdr->fDestinationAddr,
			    (UINT8*)&(rx_frame.wi_dst_addr[0]), kPacketAddrSize );
		memcpy( (UINT8*)pHdr->fSourceAddr,
			    (UINT8*)&(rx_frame.wi_src_addr[0]), kPacketAddrSize );
		memcpy( (UINT8*)&(pHdr->fLengthType),
			    (UINT8*)&(rx_frame.wi_type), kPacketTypeSize );

		if( NICReadData( id, WI_802_11_OFFSET,
						(UINT8*)pPkt + kPacketHeaderSize, pktlen + 2 ) ){
			err = eLANTERN_DriverValueRangeError;
			DEB_ASSERT( 50, ("204 ") );
			goto l_exit;
		}

#if 0	/* only for debug */
		printf("802.11:\n");
		dumpMem( (UINT8*)pPkt, pktlen );
#endif
	} else{
  l_802_3:;
		/************** 802.3`?? ********************/

		/* pPbg`FbN */
		pktlen = le16toh( rx_frame.wi_dat_len ) + kPacketHeaderSize;
#if 1	/* 10/26/2002 modified */
		if( pktlen > kPacketRxMaxLength ){
#else
		if( pktlen > MAX_RCV_LEN ){
#endif
			err = eLANTERN_DriverValueRangeError;
			DEB_ASSERT( 50, ("205 ") );
			goto l_exit;
		}
		if( NICReadData( id, WI_802_3_OFFSET, pPkt, pktlen + 2 ) ){
			err = eLANTERN_DriverValueRangeError;
			DEB_ASSERT( 50, ("206 ") );
			goto l_exit;
		}

#if 0	/* only for debug */
		printf("802.3:\n");
		dumpMem( (UINT8*)pPkt, pktlen + 2 );
#endif
	}

#if 1	/* 05/04/2002  Newtonł͕Kv */
	/* t[Ethernet̍ŏlȏɍ킹 */
	if( pktlen < kPacketRxMinLength ){
		pktlen = kPacketRxMinLength;
	}
#endif

	/* pPbgʑwɓn */
	fDriverAPI->RxReady( pPkt, pktlen );

  l_exit:;
	if( (err != noErr) && (pPkt != NULL) ){
		/* pPbgobt@ȂĂ悢̂? */
	}
	return( err );
}


/*--------------------------------
  ::NICTxInt:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICTxInt( UINT16  stat )
{
	NewtonErr	err = noErr;

	/* MBusyԂ */
	fStatus &= ~DRV_STAT_TX_BUSY;

	if( (stat & WI_EV_TX_EXC) != 0 ){
		err = eLANTERN_DriverValueRangeError;
	}

	return( err );
}


/*--------------------------------
  ::NICWritePacket:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICWritePacket(
	UINT32 			pktlen,
	UINT8*  		pPkt,
	CBufferList*	pBufList
)
{
	NewtonErr	err = noErr;
	UINT16		idx;
	TPacketBuf*	pBlk;
	INT32		i;
	UINT8*		bpdst;

#if (TX_PKT_NUM == 1)
	if( fStatus & DRV_STAT_TX_BUSY ){
		err = kError_No_Memory;
		DEB_ASSERT( 50, ("Tx buf full\n") );
		goto l_end;
	}
	idx = 0;
	pBlk = &(fTxPktBufArray[idx]);
#else
	/* Mobt@v[Ƀobt@邩𒲂ׂ */
	pBlk = (TPacketBuf*)(fPtrListTxBufPool->First());
	if( pBlk == nil ){
		err = kError_No_Memory;
		DEB_ASSERT( 50, ("Tx buf full\n") );
		goto l_end;
	}
	fPtrListTxBufPool->RemoveFirst();
#endif

	/*
	 * pPbgsĂ΁CEthernetł̍ŏpPbg܂Ŋg
	 */
	if( pktlen < kPacketTxMinLength ){
		pktlen = kPacketTxMinLength;
	}

	pBlk->bytes = pktlen;

	bpdst = &(pBlk->buf[0]);

	if( pBufList ){
		pBufList->ResetMark();

		for( i = pktlen ; --i >= 0 ; ){			
			*bpdst++ = pBufList->Get();
		}
	} else{
		for( i = pktlen ; --i >= 0 ; ){
			*bpdst++ = *pPkt++;
		}
	}

#if (TX_PKT_NUM == 1)
#else
	/* Mobt@L[ɓo^ */
	fPtrListTxBufQueue->InsertLast( pBlk );
#endif

  l_end:;
	return( err );
}


/*--------------------------------
  ::NICXmit:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICXmit( void )
{
	struct wi_frame		tx_frame;
	TPacketBuf*			pBlk;
	TPacketHeader*		pHdr;
	UINT16				ether_type;
	NewtonErr			err = noErr;
	UINT8*				pBuf;
	INT32				pktlen;
	INT32				ret;

	/* Mł΂ɔ */
	if( fStatus & DRV_STAT_TX_BUSY ){
		DEB_ASSERT( 50, ("NIC is busy\n") );
		goto l_end;
	}

	/* Mobt@L[1pPbgo */
#if (TX_PKT_NUM == 1)
	pBlk = &(fTxPktBufArray[0]);
#else
	pBlk = (TPacketBuf*)(fPtrListTxBufQueue->First());
	if( pBlk == nil ){
		DEB_ASSERT( 80, ("Tx queue is empty\n") );
		goto l_end;
	}
	fPtrListTxBufQueue->RemoveFirst();
#endif
	pBuf	= &(pBlk->buf[0]);
	pktlen	= pBlk->bytes;

	/* t[NA */
	memset( (INT8*)&tx_frame, 0, sizeof(tx_frame) );

	pHdr = (TPacketHeader*)pBuf;
	ether_type = ntohs( pHdr->fLengthType );

	if( (ether_type == ETHER_TYPE_IP) || (ether_type == ETHER_TYPE_ARP) ){
		memcpy( (UINT8*)&(tx_frame.wi_addr1[0]),
			    (UINT8*)pHdr->fDestinationAddr, kPacketAddrSize );

		memcpy( (UINT8*)&(tx_frame.wi_addr2[0]),
			    (UINT8*)pHdr->fSourceAddr, kPacketAddrSize );

		memcpy( (UINT8*)&(tx_frame.wi_dst_addr[0]),
			    (UINT8*)pHdr->fDestinationAddr, kPacketAddrSize );

		memcpy( (UINT8*)&(tx_frame.wi_src_addr[0]),
			    (UINT8*)pHdr->fSourceAddr, kPacketAddrSize );

		tx_frame.wi_dat_len		= htole16( pktlen - WI_SNAPHDR_LEN );
		tx_frame.wi_frame_ctl	= htole16( WI_FTYPE_DATA );
		tx_frame.wi_dat[0]		= htons( WI_SNAP_WORD0 );
		tx_frame.wi_dat[1]		= htons( WI_SNAP_WORD1 );
		tx_frame.wi_len			= htons( pktlen - WI_SNAPHDR_LEN );
		tx_frame.wi_type		= pHdr->fLengthType;

		/* wb_n[hEFAɏ */
		ret = NICWriteData( fIDTxBuf, 0, &tx_frame, sizeof(struct wi_frame) );
		if( ret ){
			DEB_ASSERT( 50, ("101 ") );
			goto l_release;
		}

		/* pPbĝ̂n[hEFAɏ */
		ret = NICWriteData( fIDTxBuf, WI_802_11_OFFSET, pBuf + kPacketHeaderSize,
					  pktlen - kPacketHeaderSize + 2 );
		if( ret ){
			DEB_ASSERT( 50, ("102 ") );
			goto l_release;
		}
	} else{
		tx_frame.wi_dat_len	= htole16( pktlen );

		/* wb_n[hEFAɏ */
		ret = NICWriteData( fIDTxBuf, 0, &tx_frame, sizeof(struct wi_frame) );
		if( ret ){
			DEB_ASSERT( 50, ("103 ") );
			goto l_release;
		}

		/* pPbĝ̂n[hEFAɏ */
		ret = NICWriteData( fIDTxBuf, WI_802_3_OFFSET, pBuf, pktlen + 2 );
		if( ret ){
			DEB_ASSERT( 50, ("104 ") );
			goto l_release;
		}
	}

  l_release:;
	/* ML[obt@ */
#if (TX_PKT_NUM == 1)
#else
	/* obt@v[ɕԋp */
	fPtrListTxBufPool->InsertLast( pBlk );
#endif

	if( ret ){
		err = eLANTERN_DriverHardwareFailure;
		goto l_end;
	}

	/* n[hEFAőMJn */
	if( NICCmd( WI_CMD_TX | WI_RECLAIM, fIDTxBuf ) ){
		DEB_ASSERT( 50, ("Xmit missed\n") );
		err = eLANTERN_DriverHardwareFailure;
		goto l_end;
	}
	fStatus |= DRV_STAT_TX_BUSY;

  l_end:;
	return( err );
}


/*--------------------------------
  ::NICSetMulti:
--------------------------------*/
void  TLucentWaveLAN::NICSetMulti( void )
{
	struct wi_ltv_mcast		mcast;
	const INT16				MCAST_NUM = sizeof(mcast.wi_mcast)/sizeof(mcast.wi_mcast[0]);
	INT32					num;

	/* ]pobt@NA */
	memset( (INT8*)&mcast, 0, sizeof(mcast) );

	mcast.wi_type	= WI_RID_MCAST;
	mcast.wi_len	= ((kPacketAddrSize / 2) * MCAST_NUM) + 1;

	/*
	 * SM[ĥƂ(ʂ̕@őSM[hɐݒ肷̂)
	 * }`LXgAhX̓[߂̂𗬂ŏ.
	 */
	if( 0 ){
		goto l_set_nic;
	}

	/*
	 * }`LXgAhXꗗ̓eԂɃXLāC
	 * ]p̕ϐɃRs[D
	 */
	num = MCAST_NUM;
	fMulticastAddrDataBase->GetAddrList( (TEtherAddr*)mcast.wi_mcast, &num );

	/* n[hEFAɃZbg */
	mcast.wi_len = ((kPacketAddrSize / 2) * num) + 1;

	DEB_ASSERT( 90, (" num = %d\n",num) );
	do {
		INT16	ii, jj;
		UINT8*	bp;

		for( jj = 0 ; jj < num ; jj++ ){
			DEB_ASSERT( 90, (" Entry #%d: ",jj) );
			bp = (UINT8*)&mcast.wi_mcast[jj];
			for( ii = 0 ; ii < kPacketAddrSize ; ii++ ){
				DEB_ASSERT( 90, ("%02X ",*bp++) );
			}
			DEB_ASSERT( 90, ("\n") );
		}
	} while( 0 );

  l_set_nic:;
	NICWriteRecord( (struct wi_ltv_gen*)&mcast );
}


/*--------------------------------
  ::NICAddDeleteMulticastAddr:
--------------------------------*/
NewtonErr TLucentWaveLAN::NICAddDeleteMulticastAddr(UChar* addr, Boolean add)
{
	NewtonErr	err			= noErr;
	Boolean		updateNIC	= false;

	/* f[^x[X̃}`LXgAhXɒǉ/폜 */
	err = fMulticastAddrDataBase->AddDeleteMulticastAddr(addr, add, &updateNIC);

	/* G[C邢NIC̐ݒXVKvȂƂɂ͂Ŕ */
	if( err || !(updateNIC) ){
		return( err );
	}

	NICSetMulti();

	return( err );
}


/*--------------------------------
  ::NICGetLinkIntegrity:
--------------------------------*/
Boolean  TLucentWaveLAN::NICGetLinkIntegrity()
{
	/* Can't get link back from Tamarack chip */
	return( true );
}


/*--------------------------------
  ::NICSetPromiscuous:
--------------------------------*/
NewtonErr  TLucentWaveLAN::NICSetPromiscuous( ULong  prom )
{
	/* promiscuous[h ON/OFFoĂ */
	ULong	status = fStatus & (~DRV_STAT_RX_PROMISCUOUS);

	fStatus = status | (prom ? DRV_STAT_RX_PROMISCUOUS : 0);

	return( noErr );
}






/*=============================================================
  TMulticastAddrDataBaseNX `
=============================================================*/

/*
 * TMulticastAddrDataBase::TMulticastAddrDataBase()
 *
 * TMulticastAddrDataBase constructor
 */
/*--------------------------------
  ::TMulticastAddrDataBase:
  RXgN^
--------------------------------*/
TMulticastAddrDataBase::TMulticastAddrDataBase()
{
}


/*
 * TMulticastAddrDataBase::~TMulticastAddrDataBase()
 *
 * TMulticastAddrDataBase destructor
 */
/*--------------------------------
  ::~TMulticastAddrDataBase:
  fXgN^
--------------------------------*/
TMulticastAddrDataBase::~TMulticastAddrDataBase()
{
	TMulticastAddrEntry* addrEntry;

	/*
	 * f[^x[XɕێĂAhXGg̃Sĉ
	 */

	/* ŏIGgɂȂ܂ŌJԂ */
	while ((addrEntry = (TMulticastAddrEntry*)fMulticastAddressList.Last()) != nil){
		/* ŏIGgXg폜 */
		fMulticastAddressList.RemoveLast();

		/* Gg̃ */
		delete addrEntry;
	}
}


/*
 *	TMulticastAddrDataBase::AddDeleteMulticastAddr(
 *		UChar* addr, Boolean add, Boolean* updateNIC)
 *
 *	Add or delete a multicast address
 */
/*--------------------------------
  ::AddDeleteMulticastAddr:
--------------------------------*/
NewtonErr TMulticastAddrDataBase::AddDeleteMulticastAddr(
	UChar*		addr,
	Boolean		add,
	Boolean*	updateNIC
)
{
	NewtonErr	err = noErr;

	*updateNIC = false;

	/* w肳ꂽAhXݕێĂ郊XgT */
	TMulticastAddrEntry* addrEntry = FindMulticastAddr(addr);

	if( add ){
		/*-- ǉ --*/
		if( addrEntry != nil ){
			/*
			 * w肳ꂽAhXɃXgɂȂC
			 * QƃJEg𑝂₷D
			 */
			addrEntry->fRequestCount++;
		} else{
			/*
			 * w肳ꂽAhXXgɂȂƂ́C
			 * EVɃGgǉ
			 * ENIC̃WX^XV邱Ƃʒm
			 */
			addrEntry = new TMulticastAddrEntry;
			XREQUIRE_ACTION(addrEntry, exit, err = kError_No_Memory;);
			
			for( ULong i = 0 ; i < kPacketAddrSize ; i++ ){
				addrEntry->fMulticastAddr[i] = addr[i];
			}
			/* QƃJEg ==  1 */
			addrEntry->fRequestCount = 1;

			/* Xgɉ */
			fMulticastAddressList.InsertLast(addrEntry);

			/* NICWX^XV̕Kv */
			*updateNIC = true;
		}
	} else{
		/*-- 폜 --*/
		if( addrEntry != nil ){
			/* QƃJEg炷 */
			if( (--addrEntry->fRequestCount) == 0 ){
				/*
				 * JE^0ɂȂƂ́C̃GgXg폜
				 */
				fMulticastAddressList.Remove(addrEntry);
				delete addrEntry;
				*updateNIC = true;
			}
		} else{
			/* XgɃGgȂCƂُ͈̂Ԃ̂͂ */
			err = eLANTERN_DriverValueRangeError;
		}
	}
	
  exit:;
	return( err );
}


/*
 * TMulticastAddrEntry* TMulticastAddrDataBase::FindMulticastAddr(UChar* addr)
 *
 * Find the multicast address entry in the list
 */
/*--------------------------------
  ::FindMulticastAddr:
--------------------------------*/
TMulticastAddrEntry* TMulticastAddrDataBase::FindMulticastAddr(UChar* addr)
{
	CListIterator	iter( &fMulticastAddressList );
	register ULong	addr0 = ((ULong*)addr)[0];
	register ULong	addr1 = ((ULong*)addr)[1];

	/* ܂̓Xg̐擪̃ACe|Cg */
	TMulticastAddrEntry* addrEntry = (TMulticastAddrEntry*)iter.FirstItem();
	while( addrEntry ){
		/* AhXr */
		ULong notMatch = (((ULong*)addrEntry->fMulticastAddr)[0] ^ addr0) |
						((((ULong*)addrEntry->fMulticastAddr)[1] ^ addr1) & 0xffff0000);

		/* vĂ΃[v𔲂 */
		if( !notMatch ){
			break;
		}

		/* ̃ACe */
		addrEntry = (TMulticastAddrEntry*)iter.NextItem();
	}

	return( addrEntry );
}


/*--------------------------------
  ::GetAddrList:
  o^ĂAhXꗗԂ
--------------------------------*/
NewtonErr  TMulticastAddrDataBase::GetAddrList(
	TEtherAddr	etherList[],
	INT32*		pEntNum
)
{
	INT32			max;
	INT32			i;
	CListIterator	iter( &fMulticastAddressList );
	NewtonErr		err = noErr;

	max = *pEntNum;
	i = 0;

	/* ܂̓Xg̐擪̃ACe|Cg */
	TMulticastAddrEntry*	addrEntry = (TMulticastAddrEntry*)iter.FirstItem();
	while( addrEntry && (i < max) ){
		memcpy( &(etherList[i]), addrEntry->fMulticastAddr, sizeof(TEtherAddr) );
		i++;

		/* ̃ACe */
		addrEntry = (TMulticastAddrEntry*)iter.NextItem();
	}

	*pEntNum = i;

	return( err );
}




/*-------------
  end of file
-------------*/
